package TcpClient;
use Socket;
use strict;
use utf8;
######################################################################
# TCP クライアントモジュール
# TcpClient.pm 1.0
# Copyright (C) 1999-2013 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
#	TcpClient->new(
#		'handle'	=>	\*FTP,
#		'host'		=>	$hostname,
#		'portname'	=>	'ftp',
#	)->tcp_connect;
######################################################################
sub new ($;@) {
my $pkg = shift;
my $this = {@_};
bless $this;
$this->{'handle'} = 'TCPCLIENT' . ++$TcpClient::count if !$this->{'handle'};
$this->{'port'} = getservbyname($this->{'portname'}, 'tcp') if !defined $this->{'port'} && $this->{'portname'};
$this->{'sockaddr'} = sockaddr_in($this->{'port'},inet_aton($this->{'host'}));
$this;
}

######################################################################
#ソケットを開いて接続する
sub tcp_connect ($) {
my $this = shift;
my $handle = $this->{'handle'};
if (!socket($handle, PF_INET, SOCK_STREAM, getprotobyname('tcp'))) {
	push(@{$this->{'dialog'}},'ソケットを開けませんでした。');
	return 0;
}
if (!connect($handle, $this->{'sockaddr'})) {
	push(@{$this->{'dialog'}},'ソケットに接続できせんでした。HOST : ' . $this->host);
	return 0;
}
binmode $this->{'handle'};

#バッファリングを止める
use FileHandle;
$handle->autoflush(1);
return 1;
}

sub handle ($) {
my $this = shift;
return $this->{'handle'};
}

sub host ($) {
my $this = shift;
return (defined $this->{'host'}) ? $this->{'host'} : '';
}

sub tcp_close ($) {
my $this = shift;
close($this->{'handle'});
}

########################################################################
#メッセージ
sub dialog ($) {
my $this = shift;
my @dialog = (ref $this->{'dialog'} eq 'ARRAY') ? @{$this->{'dialog'}} : ();
undef @{$this->{'dialog'}};
return @dialog;
}


1;